<%@ LANGUAGE = VBScript %>
<%
'
' shopfactory_order.asp is the Active Server Pages version of
' shopfactory_order.cgi and works exactly the same way.
'
' Requirements of shopfactory_order.asp:
'    IIS 4.0
'    (should work on IIS 3.0+ but has not been tested)
'
' Requirements of shopfactory_email.asp:
'    IIS 4.0 with SMTP service
'    (should work with Exchange Server instead of SMTP service
'    but has not been tested.  Our script uses the CDONTS object
'    which is included with the SMTP service and apparently with
'    Exchange Server)
'
'

' Valid referers
Const Num_Referers = 4
Dim Referers(4)		' Unfortunately this has to be 11 not Num_Referers which would be neater
Referers(0) = "ordernav.html"			' Standard
Referers(1) = "shopfactory_order.asp"	' Custom fields
Referers(2) = "customerdtl.html"		' Should be unnecessary
Referers(3) = "deliverydtl.html"		' Should be unnecessary
Referers(4) = "order4.html"				' Should be unnecessary

' External_Prefix is the prefix to append to lockssl-on.gif and thankyou_url if necessary.
' If you want to use "/files/lockssl-on.gif" and "/files/thankyou.html" then External_Prefix
' must be set to '/files/'
External_Prefix = ""

' Carriage Return/Linefeed Pair
CRLF = Chr(13) & Chr(10)

' Credit Card Expiry Years
CC_Expiry_Years = Request.Form("cc_expiry_years")
If Len(CC_Expiry_Years) = 0 Then
	CC_Expiry_Years = "2000,2001,2002,2003,2004,2005,2006,2007,2008,2009,2010,2011"
End If

' Default language translations '
ln_badreferer		= "Bad Referrer - Access Denied"
ln_badreferer_desc	= "The URL of the form that is trying to use this CGI application is not in the list of valid referrers."
ln_error_missing	= "Missing Fields"
ln_error_cc_invalid = "The credit card number you entered is invalid"
ln_error_fields     = "The following field(s) require data"
ln_error			= "Error"
ln_orderfrom		= "Order from"
ln_submitted		= "Submitted by"
ln_email			= "email"
ln_date				= "date"
ln_confirm			= "Order confirmation from"

HEADER_PRINTED = false

' ----- execution starts here -----
translateDefaults
If checkReferer() = True Then
	if checkRequired and checkValidCC and checkValid then
		dim bShowForm
		bShowForm = true
		if getfcAttrib(0, "name")&"" = "" then
			bShowForm = false
		end if
		if  Request.Form("submit")&"" = "" and bShowForm then
			printHeader
			printHTML
			printFooter
		else
			redirect
		end if
	end if
End If

sub redirect
	Response.Write "<html"
	If Request.Form("html_lang") <> "" Then
		Response.Write " lang=""" & Request.Form("html_lang") & """"
	End If
	If Request.Form("html_dir") <> "" Then
		Response.Write " dir=""" & Request.Form("html_dir") & """"
	End If
	Response.Write ">" & CRLF
	If Request.Form("http_charset") <> "" Then
		Response.Write "<meta http-equiv=""Content-Type"" content=""text/html; charset=" & Request.Form("http_charset") & """>" & CRLF
	End If
	%>
	<script language="javascript">
	function document_onLoad()
	{
		document.orderForm.submit();
	}
	</script>
	</head>
	<body onload="document_onLoad();" <%=bodyAttributes()%>>
	<form name="orderForm" action="shopfactory_email.asp" method="post">
	<%
	for each key in Request.Form
		if left(key, 2) <> "fc" and key <> "submit" then
			Response.Write("<input type=""hidden"" name=""" & key & """ value=""" & Request.Form(key) & """>" & CRLF)
		end if
	next
	Response.Write "</form></body></html>"
end sub

Sub printHeader
	if not HEADER_PRINTED then
		Response.Write "<html"
		If Request.Form("html_lang") <> "" Then
			Response.Write " lang=""" & Request.Form("html_lang") & """"
		End If
		If Request.Form("html_dir") <> "" Then
			Response.Write " dir=""" & Request.Form("html_dir") & """"
		End If
		Response.Write ">" & CRLF
		Response.Write "<head>" & CRLF
		If Request.Form("http_charset") <> "" Then
			Response.Write "<meta http-equiv=""Content-Type"" content=""text/html; charset=" & Request.Form("http_charset") & """>" & CRLF
		End If
		Response.Write "</head>" & CRLF
		Response.Write "<body" & bodyAttributes() & ">"
		
		HEADER_PRINTED = true
	end if	
End Sub

Sub printFooter
	Response.Write "</body></html>"
End Sub

sub printHTML
	%>
	<center><img src="<%=External_Prefix%>lockssl-on.gif"></center><br>
	<center><p><b><%=Request.Form("ln_fill_in_order")%></b></p></center>
	<center>
	<form name="orderForm" method="post">
	<table border="3" cellpadding="2" width="90%" bgcolor="<%=Request.Form("doc_table_bgcolor")%>">
		<%=getAllfcHTML()%>
	</table>
	</center>
	<%
	for each key in Request.Form
		if left(key, 6) <> "field_" and key <> "submit" then
			Response.Write("<input type=""hidden"" name=""" & key & """ value=""" & Request.Form(key) & """>" & CRLF)
		end if
	next
	%>
	<p align="center"><input type="reset" value="<%=Request.Form("ln_clear")%>">
	<input type="submit" name="submit" value="<%=Request.Form("ln_next")%>"></p>
	</form>
	<%
end sub

Sub translateDefaults
	If Request.Form("ln_badreferer") <> "" then
		ln_badreferer = Request.Form("ln_badreferer")
	End If
	If Request.Form("ln_badreferer_desc") <> "" then
		ln_badreferer_desc = Request.Form("ln_badreferer_desc")
	End If
	If Request.Form("ln_error_missing") <> "" then
		ln_error_missing = Request.Form("ln_error_missing")
	End If
	If Request.Form("ln_error_fields") <> "" then
		ln_error_fields = Request.Form("ln_error_fields")
	End If
	If Request.Form("ln_error_cc_invalid") <> "" then
		ln_error_cc_invalid = Request.Form("ln_error_cc_invalid")
	End If
	If Request.Form("ln_error") <> "" then
		ln_error = Request.Form("ln_error")
	End If
	If Request.Form("ln_orderfrom") <> "" then
		ln_orderfrom = Request.Form("ln_orderfrom")
	End If
	If Request.Form("ln_submitted") <> "" then
		ln_submitted = Request.Form("ln_submitted")
	End If
	If Request.Form("ln_email") <> "" then
		ln_email = Request.Form("ln_email")
	End If
	If Request.Form("ln_date") <> "" then
		ln_date = Request.Form("ln_date")
	End If
	If Request.Form("ln_confirm") <> "" then
		ln_confirm = Request.Form("ln_confirm")
	End If
End Sub

Function checkReferer()
	checkReferer = True
	Referer = Request.ServerVariables("HTTP_REFERER")
	If Len(Referer) = 0 Then
		Exit Function
	End If

	For i = 0 To Num_Referers
		If InStr(Referer, Referers(i)) > 0 Then
			Exit Function
		End If
	Next

	printHeader
	Response.Write "<center><h1>" & ln_badreferer & "</h1></center>" & CRLF
	Response.Write ln_badreferer_desc & CRLF
	printFooter

	checkReferer = False
End Function

function checkRequired
	dim errorcnt
	dim errorArray
	errorcnt = 0
	errorArray = Array(errorcnt)
	if isArray(REQUIRED) then
		for each require in REQUIRED
			if trim(Request.Form(require))&"" = "" then
				redim preserve errorArray(errorcnt)
				errorArray(errorcnt) = require
				errorcnt = errorcnt + 1
			end if
		next
	end if
	if Request.Form("submit")&"" <> "" then
		dim s
		dim index
		dim fieldName
		index     = 0
		fieldName = getfcAttrib(index, "name")
		while  fieldName&"" <> ""
			if getfcAttrib(index, "isRequired") and _
			   Request.Form(fieldName)&"" = "" then
				redim preserve errorArray(errorcnt)
				errorArray(errorcnt) = right(fieldName, len(fieldName)-6)
				errorcnt = errorcnt + 1
			end if
			index     = index + 1
			fieldName = getfcAttrib(index, "name")
		wend
	end if
	if errorcnt > 0 then
		checkRequired = false
		printHeader
		Response.Write "<center><h1>" & ln_error_missing & "</h1></center>" & CRLF
		Response.Write ln_error_fields & CRLF
		Response.Write("<ul><li>" & join(errorArray, "<li>") & "</ul>")
		printFooter
	else
		checkRequired = true
	end if
end function

function odd(num)
	if (num mod 2) = 0 then
		odd = false
	else
		odd = true
	end if
end function
		
function validateCC(n)
	dim num
	dim i
	dim c
	for i = 1 to len(n)
		c = mid(n, i, 1)
		if isNumeric(c) then
			num = num & c
		end if
	next
	dim valid
	dim length
	length = len(num)
	if length < 12 then
		valid = false
	else
		dim x
		dim y
		x = 0
		y = 0
		if odd(length) then
			for i = length-1 to 1 step -1
				y = (asc(mid(num, i, 1)) - asc("0"))
				if odd(i-1) then
					y = y * 2
				end if
				x = x + y
			next
				if y >= 10 then
					y = ((y - 10) + 1)
				end if
		else
			for i = length-1 to 1 step -1
				y = (asc(mid(num, i, 1)) - asc("0"))
				if not odd(i-1) then
					y = y * 2
				end if
				if y >= 10 then
					y = ((y - 10) + 1)
				end if
				x = x + y
				next
		end if
		x = (10 - (x mod 10))
		if x = 10 then
			x = 0
		end if
		if x = (asc(mid(num, length, 1)) - asc("0")) then
			if mid(num, 1, 1) > 0 then
				valid = true
			end if
		else
			valid = false
		end if
	end if
	validateCC = valid
end function

function validateEmail(email)
	dim i
	dim c
	for i = 1 to len(email)
		c = mid(email, i, 1)
		if not ( _
			   (asc(c) >= asc("A") and asc(c) <= asc("Z")) _
			or (asc(c) >= asc("a") and asc(c) <= asc("z")) _
			or (asc(c) >= asc("0") and asc(c) <= asc("9")) _
			or      c   = "@" _
			or      c   = "." _
			or      c   = "_" _
		) then
			validateEmail = false
			exit function
		end if
	next
	
	dim atpos
	atpos = instr(1, email, "@")
	if atpos = 0 or atpos = 1 or atpos = len(email) then
		validateEmail = false
		exit function
	end if
	
	dim dotpos
	dim prevpos
	prevpos = atpos
	do
		dotpos = instr(prevpos+1, email, ".")
		if ((dotpos - prevpos) <= 1 and dotpos <> 0) _
		or dotpos = len(email) _
		or (dotpos = 0 and prevpos = atpos) then
			validateEmail = false
			exit function
		end if
		prevpos = dotpos
	loop while dotpos > 0
	validateEmail = true
end function

function checkValidCC
	dim errorcnt
	dim errorArray
	errorcnt = 0
	errorArray = Array(errorcnt)
	if Request.Form("submit")&"" <> "" then
		dim s
		dim index
		dim fieldName
		index     = 0
		fieldName = getfcAttrib(index, "name")
		while  fieldName&"" <> ""
			dim valid
			dim values
			values = split(Request.Form(fieldName), ", ")
			for each value in values
				if ucase(getfcAttrib(index, "typeData")) = "CREDITCARD" then			
					valid = validateCC(value)
					if not valid then
						redim preserve errorArray(errorcnt)
						errorArray(errorcnt) = getfcAttrib(index, "label")
						errorcnt = errorcnt + 1
					end if
				end if
			next
			index     = index + 1
			fieldName = getfcAttrib(index, "name")
		wend
	end if
	if errorcnt > 0 then
		checkValidCC = false
		printHeader
		Response.Write "<center><h1>" & ln_error_cc_invalid & "</h1></center>" & CRLF
		Response.Write ln_error_fields & CRLF
		for each label in errorArray
			Response.Write("<ul><li>" & join(errorArray, "<li>") & "</ul>")
		next
		printFooter
	else
		checkValidCC = true
	end if
end function

function checkValid
	dim errorcnt
	dim errorArray
	errorcnt = 0
	errorArray = Array(errorcnt)
	if Request.Form("submit")&"" <> "" then
		dim index
		dim fieldName
		index     = 0
		fieldName = getfcAttrib(index, "name")
		while  fieldName&"" <> ""
			dim valid
			dim values
			valid  = false
			values = split(Request.Form(fieldName), ", ")
			for each value in values
				select case getfcAttrib(index, "typeData")
				case "TEXT"
					valid = true
				case "EMAIL"
					valid = validateEmail(value)
				case "NUMBER"
					if isNumeric(value) then
						valid = true
					end if
				case "PHONE"
					'/^\+?\s*((\(\d+(\s*-?\s*\d+)*\)\s*-?\s*)|(\d+(\s*-?\s*\d+)*\s*-?\s*))+\s*$/
					valid = true
				end select
				if not valid then
					redim preserve errorArray(errorcnt)
					errorArray(errorcnt) = getfcAttrib(index, "label")
					errorcnt = errorcnt + 1
				end if
			next
			index     = index + 1
			fieldName = getfcAttrib(index, "name")
		wend
	end if
	if errorcnt > 0 then
		checkValid = false
		printHeader
		Response.Write "<center><h1>" & ln_error & "</h1></center>" & CRLF
		for each label in errorArray
			Response.Write("<ul><li>" & join(errorArray, "<li>") & "</ul>")
		next
		printFooter
	else
		checkValid = true
	end if
end function

function getfcAttrib(index, attrib)
	dim value
	value = Request.Form("fc"&index&attrib)
	if value&"" <> "" then
		select case attrib 
		case "name"
			value = "field_" & value
		case "isRequired" 
			if value = "true" then
				value = true
			elseif value = "false" then
				value = false
			end if
		case "isMultiChoice"
			if value = "true" then
				value = true
			elseif value = "false" then
				value = false
			end if
		end select
	end if
	getfcAttrib = value
end function

function getfcChoiceAttrib(index, choice, attrib)
	getfcChoiceAttrib =  Request.Form("fc"&index&"choices"&choice&attrib)
end function

Function bodyAttributes()
	s = ""

	If Request.Form("bgcolor") <> "" Then
		s = s & " bgcolor=""" & Request.Form("bgcolor") & """"
	End If
	If Request.Form("link_color") <> "" Then
		s = s & " link=""" & Request.Form("link_color") & """"
	End If
	If Request.Form("vlink_color") <> "" Then
		s = s & " vlink=""" & Request.Form("vlink_color") & """"
	End If
	If Request.Form("alink_color") <> "" Then
		s = s & " alink=""" & Request.Form("alink_color") & """"
	End If
	If Request.Form("text_color") <> "" Then
		s = s & " text=""" & Request.Form("text_color") & """"
	End If

	bodyAttributes = s
End Function

function getAllfcHTML
	dim s
	dim index
	dim fieldName
	s         = ""
	index     = 0
	fieldName = getfcAttrib(index, "name")
	while  fieldName&"" <> ""
		if ucase(getfcAttrib(index, "typeForm")) = "HIDDEN" then
			s = s & getfcHTML(index)
		else
			s = s & "<TR BGCOLOR=""" & Request.Form("doc_table_bgcolor") & """ valign=""top"">"
			s = s & "<TD ALIGN=""right""><FONT SIZE=+1 COLOR=""" & Request.Form("doc_table_text") & """>"
			if getfcAttrib(index, "isRequired") then
				s = s & "*"
			end if
			s = s & right(fieldName, len(fieldName)-6) & ":"
			s = s & "</FONT></TD>"
			s = s & "<TD ALIGN=""left""><FONT SIZE=+1 COLOR=""" & Request.Form("doc_table_text") & """>"
			s = s & getfcHTML(index)
			s = s & "</FONT></TD>"
			s = s & "</TR>" & CRLF
		end if
		index     = index + 1
		fieldName = getfcAttrib(index, "name")
	wend
	getAllfcHTML = s
end function

function getfcHTML(index)
	dim s
	dim fieldName
	dim typeForm
	dim values      
	dim choiceIndex 
	dim choiceName  
	fieldName = getfcAttrib(index, "name")
	typeForm  = getfcAttrib(index, "typeForm")
	if right(typeForm, 9) = "_CHECKBOX" then
		typeForm = "CHECKBOX"
	else 
		if right(typeForm, 6) = "_COMBO" or right(typeForm, 8) = "_LISTBOX" then
			typeForm = "SELECT"
		else 
			if right(typeForm, 6) = "_RADIO" then
				typeForm = "RADIO"
			end if
		end if
	end if
	select case typeForm
	case "LABEL"
		if Request.Form(fieldName) & "" = "" then
			s = s & getfcChoiceAttrib(index, 0, "value")
		else
			s = s & Request.Form(fieldName)
		end if
	case "HIDDEN"
		s = s & "<INPUT TYPE=""hidden"" NAME=""" & fieldName & """"
		if getfcAttrib(index, "cols") > 0 then
			s = s & " SIZE=""" & getfcAttrib(index, "cols") & """"
		end if
		if getfcAttrib(index, "maxLength") > 0 then
			s = s & " MAXLENGTH=""" & getfcAttrib(index, "maxLength") & """"
		end if
		if Request.Form(fieldName) & "" = "" then
			s = s & " VALUE=""" & getfcChoiceAttrib(index, 0, "value") & """"
		else
			s = s & " VALUE=""" & Request.Form(fieldName) & """"
		end if
		s = s & ">"
	case "TEXT"
		s = s & "<INPUT TYPE=""text"" NAME=""" & fieldName & """"
		if getfcAttrib(index, "cols") > 0 then
			s = s & " SIZE=""" & getfcAttrib(index, "cols") & """"
		end if
		if getfcAttrib(index, "maxLength") > 0 then
			s = s & " MAXLENGTH=""" & getfcAttrib(index, "maxLength") & """"
		end if
		if Request.Form(fieldName) & "" = "" then
			s = s & " VALUE=""" & getfcChoiceAttrib(index, 0, "value") & """"
		else
			s = s & " VALUE=""" & Request.Form(fieldName) & """"
		end if
		s = s & ">" 
	case "TEXTAREA"
		s = s & "<TEXTAREA WRAP=""soft"" NAME=""" & fieldName & """"
		if getfcAttrib(index, "cols") > 0 then
			s = s & " COLS=""" & getfcAttrib(index, "cols") & """"
		end if
		if getfcAttrib(index, "rows") > 0 then
			s = s & " ROWS=""" & getfcAttrib(index, "rows") & """"
		end if
		if getfcAttrib(index, "maxLength") > 0 then
			s = s & " ONCHANGE=""if (this.value.length > " & getfcAttrib(index, "maxLength") & ") this.value=this.value.substring(0," & getfcAttrib(index, "maxLength") & ");"""
		end if
		s = s & ">"
		if Request.Form(fieldName) & "" = "" then
			s = s & getfcChoiceAttrib(index, 0, "value")
		else
			s = s & Request.Form(fieldName)
		end if
		s = s & "</TEXTAREA>" 
	case "CHECKBOX"
		values      = split(Request.Form(fieldName), ", ")
		choiceIndex = 0
		choiceName  = getfcChoiceAttrib(index, choiceIndex, "name")
		while  choiceName&"" <> ""
			s = s & "<INPUT TYPE=""checkbox"" NAME=""" & fieldName & """ VALUE=""" & getfcChoiceAttrib(index, choiceIndex, "value") & """"
			for each value in values
				if value = getfcChoiceAttrib(index, choiceIndex, "value") then
					s = s & " CHECKED"
				end if
			next
			s = s & ">" & choiceName & "&nbsp;<BR>"
			choiceIndex = choiceIndex + 1
			choiceName = getfcChoiceAttrib(index, choiceIndex, "name")
		wend
	case "RADIO"
		choiceIndex = 0
		choiceName  = getfcChoiceAttrib(index, choiceIndex, "name")
		while  choiceName&"" <> ""
			s = s & "<INPUT TYPE=""radio"" NAME=""" & fieldName & """" & " VALUE=""" & getfcChoiceAttrib(index, choiceIndex, "value") & """"
			if Request.Form(fieldName) = getfcChoiceAttrib(index, choiceIndex, "value") then
				s = s & " CHECKED"
			end if
			s = s & ">" & choiceName & "&nbsp;<BR>"
			choiceIndex = choiceIndex + 1
			choiceName = getfcChoiceAttrib(index, choiceIndex, "name")
		wend
	case "SELECT"
		s = s & "<FONT SIZE=""-1""><SELECT NAME=""" & fieldname & """"
		if getfcAttrib(index, "rows") > 0 then
			s = s & " SIZE=""" & getfcAttrib(index, "rows") & """"
		end if
		if getfcAttrib(index, "isMultiChoice") then
			s = s &	" MULTIPLE>"
		else
			s = s & ">"
		end if
		s = s & " <OPTION VALUE=""""><BR>"
		if getfcAttrib(index, "isMultiChoice") then
			values      = split(Request.Form(fieldName), ", ")
			choiceIndex = 0
			choiceName  = getfcChoiceAttrib(index, choiceIndex, "name")
			while  choiceName&"" <> ""
				s = s & " <OPTION VALUE=""" & getfcChoiceAttrib(index, choiceIndex, "value") & """"
				for each value in values
					if value = getfcChoiceAttrib(index, choiceIndex, "value") then
						s = s & " SELECTED"
					end if
				next
				s = s & ">" & choiceName & "</OPTION>"
				choiceIndex = choiceIndex + 1
				choiceName = getfcChoiceAttrib(index, choiceIndex, "name")
			wend
		else
			choiceIndex = 0
			choiceName  = getfcChoiceAttrib(index, choiceIndex, "name")
			while  choiceName&"" <> ""
				s = s & " <OPTION VALUE=""" & getfcChoiceAttrib(index, choiceIndex, "value") & """"
				if Request.Form(fieldName) = getfcChoiceAttrib(index, choiceIndex, "value") then
					s = s & " SELECTED"
				end if
				s = s & ">" & choiceName & "&nbsp;<BR>"
				choiceIndex = choiceIndex + 1
				choiceName = getfcChoiceAttrib(index, choiceIndex, "name")
			wend
		end if
	case else
		s = s & "<p>Unknown form control</p>"
	end select
	getfcHTML = s
end function

%>
